// 3.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "function.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static AFX_EXTENSION_MODULE MyDLL = { NULL, NULL };

#define C_EXITUSER		3
#define C_ENTERUSER		4
#define C_PRIVATEUSER	5
#define C_ALLUSER		6
#define C_CHANGEMODE	7
#define C_ALERTUSER		8
#define C_SOUND			11

CmyWinampInfo myWinAmp;

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("My.DLL Initializing!\n");

		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(MyDLL, hInstance))
			return 0;

		new CDynLinkLibrary(MyDLL);

	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("My.DLL Terminating!\n");

		// Terminate the library before destructors are called
		AfxTermExtensionModule(MyDLL);
	}
	return 1;   // ok
}

struct PluginInfo
{
	int	plugin_type;			//   ,  1,  dll        
	CString *plugin_name;		//   
	CString	*plugin_version;	//   
	CString	*plugin_autor;		//   
};


extern "C" __declspec(dllexport) void GetPluginInfo(PluginInfo* pPluginInfo, DWORD *pdwResult)
{
	pPluginInfo->plugin_type	= 1;
	pPluginInfo->plugin_name	= (CString*)"WinAmp TitleInfo";
	pPluginInfo->plugin_autor	= (CString*)"UMD group / support@umd.kiev.ua";
	pPluginInfo->plugin_version	= (CString*)"1.0";
	*pdwResult = 1;
}

struct HostInfo
{
	HWND pi_host;					//    ,   
	int pi_iTypeIncomingMessage;	//    ( , , )

	CString &pi_fromip;				// ip  
	CString &pi_frommac;			// mac  
	CString &pi_fromname;			// ,   

	CString &pi_toip;				// ip   / 
	CString	&pi_tomac;				// mac  / 
	CString &pi_toname;				//   ( )	

	CString &pi_ret;				//  ,      
};

struct PluginInit
{
	HWND pi_host;
};

//   ,     
extern "C" __declspec(dllexport) void GetPluginInit(PluginInit* pInitInfo, DWORD *pdwResult)
{
	if (myWinAmp)
		myWinAmp.DestroyWindow();
	
	if (myWinAmp.Create(::AfxGetMainWnd()))
	{
		myWinAmp.pMainHost = pInitInfo->pi_host; 
		myWinAmp.KillTimer(1);
		myWinAmp.SetTimer(1, 30 * 1000, NULL);

		*pdwResult = 1;
	}
	else
		*pdwResult = 0;
}

//     (      )
//      PluginHandler
extern "C" __declspec(dllexport) void GetPluginRunProc(DWORD dwCode, HostInfo *pHostInfo, DWORD *pdwResult)
{
	if (!myWinAmp)
	{
		if (!myWinAmp.Create(::AfxGetMainWnd()))
	        *pdwResult = 0;
	}

	if (myWinAmp)
	{
		myWinAmp.pMainHost = pHostInfo->pi_host;
		myWinAmp.old_winamptitle	= "";
		myWinAmp.GetWinAmpTitle();
		*pdwResult = 1;
	}
}

//      (   ).  .
/*
extern "C" __declspec(dllexport) void GetPluginSetupProc(DWORD *pdwResult)
{
	*pdwResult = 0;
}
*/

//         "" 
extern "C" __declspec(dllexport) void GetPluginCheckOnProc(DWORD dwCode, HostInfo *pHostInfo, DWORD *pdwResult)
{
	if (myWinAmp)
	{
		myWinAmp.old_winamptitle	= "";
		myWinAmp.SetTimer(1, 30 * 1000, NULL);
		*pdwResult = 1;
	}
	else
		*pdwResult = 0;
}

//         "" 
extern "C" __declspec(dllexport) void GetPluginCheckOffProc(DWORD dwCode, HostInfo *pHostInfo, DWORD *pdwResult)
{
	if (myWinAmp)
	{
		myWinAmp.old_winamptitle	= "";
		myWinAmp.KillTimer(1);
		*pdwResult = 1;
	}
	else
		*pdwResult = 0;
}

//    
extern "C" __declspec(dllexport) void PluginHandler(DWORD dwCode, HostInfo *pHostInfo, DWORD *pdwResult)
{
	CString stradd;
	
	if (myWinAmp)
		myWinAmp.pMainHost = pHostInfo->pi_host;

	//    ,   
	if (pHostInfo->pi_ret.Find("winampinfo") >= 0)
	{
		//      (C_PRIVATEUSER),   
		if (pHostInfo->pi_iTypeIncomingMessage	== C_PRIVATEUSER)
		{
			stradd.Format("MSG->%s : ",pHostInfo->pi_fromname);
		}
		else
		{
			//      (C_ALERTUSER),   
			if (pHostInfo->pi_iTypeIncomingMessage	== C_ALERTUSER)
			{
				stradd.Format("ALERT->%s : ",pHostInfo->pi_fromname);
			}
		}

		if (myWinAmp)
			myWinAmp.GetWinAmpTitle(stradd);
	}

	*pdwResult	= 0;
}